package com.fzm.mall.server.front.user.service;

import com.fzm.mall.server.front.goods.model.MarketingCoupon;
import com.fzm.mall.server.front.goods.model.MarketingCouponSku;
import com.fzm.mall.server.front.goods.model.vo.CouponVo;
import com.fzm.mall.server.front.goods.model.vo.PageVo;
import com.fzm.mall.server.front.goods.model.vo.PageVoWithOne;
import com.fzm.mall.server.front.goods.model.vo.UserCouponVo;
import com.fzm.mall.server.front.user.model.Coupon;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * <p>
 * 用户与优惠券对应表 服务类
 * </p>
 *
 * @author fzm
 * @since 2021-03-19
 */
public interface ICouponService extends IService<Coupon> {

    int updateUserCoupon(String uid, String couponId);

    List<UserCouponVo> getUserCoupon(String uid, Integer type);

    List<UserCouponVo> getCouponByGoodsId(String uid, String goodsId,Integer type,String piataiId,String marchentId);

    int addCoupon(String uid, Integer type, String couponId);

    List<MarketingCoupon> getUserCouponAndStatus(String uid, Integer type, PageVoWithOne pageVo);

    Integer getCount(String uid, Integer type,String status);

    Boolean checkHave(String uid, String couponId);

    List<MarketingCoupon> getAllUserCoupon(String uid, Integer type);

    List<String> getCategorys(String couponId);

    CouponVo getAll(String couponId, Integer type);

    List<String> getCouponIdByUid(String uid, Integer type);
}
